'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _codemirror = require('codemirror');

var _codemirror2 = _interopRequireDefault(_codemirror);

var PropTypes = _react2['default'].PropTypes;

require('codemirror/mode/javascript/javascript');

var IS_MOBILE = typeof global.navigator !== 'undefined' && (global.navigator.userAgent.match(/Android/i) || global.navigator.userAgent.match(/webOS/i) || global.navigator.userAgent.match(/iPhone/i) || global.navigator.userAgent.match(/iPad/i) || global.navigator.userAgent.match(/iPod/i) || global.navigator.userAgent.match(/BlackBerry/i) || global.navigator.userAgent.match(/Windows Phone/i));

var CodeMirrorEditor = _react2['default'].createClass({
  displayName: 'CodeMirrorEditor',

  propTypes: {
    codeText: PropTypes.string,
    onChange: PropTypes.func,
    readOnly: PropTypes.bool,
    isMobile: PropTypes.bool
  },

  getDefaultProps: function getDefaultProps() {
    return {
      isMobile: IS_MOBILE,
      onChange: function onChange() {}
    };
  },

  componentDidMount: function componentDidMount() {
    if (this._isMobile()) {
      this._removeEditor();
    } else {
      this._initialEditor();
    }
  },

  _initialEditor: function _initialEditor() {

    this._editor = _codemirror2['default'].fromTextArea(_reactDom2['default'].findDOMNode(this.refs.editor), {
      mode: 'javascript',
      lineNumbers: true,
      lineWrapping: true,
      matchBrackets: true,
      tabSize: 2,
      theme: 'solarized',
      readOnly: this.props.readOnly
    });

    this._editor.on('change', this._handleChange);
  },

  _removeEditor: function _removeEditor() {
    this._editor = null;
  },

  _handleChange: function _handleChange() {
    if (!this.props.readOnly) {
      this.props.onChange(this._editor.getValue());
    }
  },

  _isMobile: function _isMobile() {
    return !!this.props.isMobile;
  },

  render: function render() {
    var editor = undefined;

    if (this._isMobile()) {
      editor = _react2['default'].createElement(
        'pre',
        { style: { overflow: 'scroll' } },
        this.props.codeText
      );
    } else {
      editor = _react2['default'].createElement('textarea', { ref: 'editor',
        defaultValue: this.props.codeText });
    }

    return _react2['default'].createElement(
      'div',
      _extends({}, this.props, {
        className: 'code-mirror-editor' }),
      editor
    );
  }
});

exports['default'] = CodeMirrorEditor;
module.exports = exports['default'];