'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _babel = require('babel');

var babel = _interopRequireWildcard(_babel);

var _CodeMirrorEditor = require('./CodeMirrorEditor');

var _CodeMirrorEditor2 = _interopRequireDefault(_CodeMirrorEditor);

var _ReactPreview = require('./ReactPreview');

var _ReactPreview2 = _interopRequireDefault(_ReactPreview);

var PropTypes = _react2['default'].PropTypes;

var ReactPlayground = (function (_React$Component) {
  _inherits(ReactPlayground, _React$Component);

  _createClass(ReactPlayground, null, [{
    key: 'propTypes',
    value: {
      codeText: PropTypes.string.isRequired,
      previewConfig: PropTypes.object
    },
    enumerable: true
  }]);

  function ReactPlayground(props) {
    _classCallCheck(this, ReactPlayground);

    _get(Object.getPrototypeOf(ReactPlayground.prototype), 'constructor', this).call(this, props);
    this.state = {
      codeText: props.codeText,
      showCode: false
    };
  }

  _createClass(ReactPlayground, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.executeCode();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this = this;

      if (this.state.codeText !== nextProps.codeText) {
        this.setState({
          codeText: nextProps.codeText
        }, function () {
          _this.executeCode();
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      clearTimeout(this.timeoutID);
    }
  }, {
    key: 'setTimeout',
    value: (function (_setTimeout) {
      function setTimeout() {
        return _setTimeout.apply(this, arguments);
      }

      setTimeout.toString = function () {
        return _setTimeout.toString();
      };

      return setTimeout;
    })(function () {
      clearTimeout(this.timeoutID);
      this.timeoutID = setTimeout.apply(null, arguments);
    })
  }, {
    key: 'executeCode',
    value: function executeCode() {

      try {

        var compiledCodeText = babel.transform(this.state.codeText, {
          sourceMaps: 'inline'
        }).code;

        if (compiledCodeText) {
          this.setState({
            compiledCodeText: compiledCodeText
          });
        }
      } catch (err) {
        this.setTimeout(function () {
          console.error(err);
        }, 500);
      }
    }
  }, {
    key: '_onCodeToggle',
    value: function _onCodeToggle(evt) {
      evt.preventDefault();
      this.setState({
        showCode: !this.state.showCode
      });
    }
  }, {
    key: 'handleCodeChange',
    value: function handleCodeChange(value) {
      this.setState({ codeText: value });
      this.executeCode();
    }
  }, {
    key: 'renderPreview',
    value: function renderPreview(component) {
      return component;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        'div',
        _extends({}, this.props, {
          className: 'react-playground' }),
        _react2['default'].createElement(
          'div',
          { className: 'react-playground__example' },
          _react2['default'].createElement(
            'div',
            { className: 'react-playground__example-inner' },
            _react2['default'].createElement(_ReactPreview2['default'], {
              previewConfig: this.props.previewConfig,
              codeString: this.state.compiledCodeText })
          )
        ),
        this.state.showCode ? _react2['default'].createElement(_CodeMirrorEditor2['default'], {
          key: 'jsx',
          onChange: this.handleCodeChange,
          codeText: this.state.codeText }) : null,
        _react2['default'].createElement(
          'a',
          { href: '#',
            onClick: this._onCodeToggle,
            className: (0, _classnames2['default'])('react-playground__code-toggle', {
              'react-playground__code-toggle--open': this.state.showCode
            })
          },
          this.state.showCode ? 'hide code' : 'show code'
        )
      );
    }
  }]);

  return ReactPlayground;
})(_react2['default'].Component);

exports['default'] = ReactPlayground;
module.exports = exports['default'];