'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Resizable = require('./Resizable');

var _Resizable2 = _interopRequireDefault(_Resizable);

var PropTypes = _react2['default'].PropTypes;

var ReactPreview = (function (_React$Component) {
  _inherits(ReactPreview, _React$Component);

  _createClass(ReactPreview, null, [{
    key: 'propTypes',
    value: {
      codeString: PropTypes.string,
      previewConfig: PropTypes.object
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      previewConfig: {}
    },
    enumerable: true
  }]);

  function ReactPreview(props) {
    _classCallCheck(this, ReactPreview);

    _get(Object.getPrototypeOf(ReactPreview.prototype), 'constructor', this).call(this, props);
    this.state = {
      width: 320,
      height: 500
    };
  }

  _createClass(ReactPreview, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.refreshIframe(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.codeString !== this.props.codeString) {
        this.refreshIframe(nextProps);
      }
    }
  }, {
    key: 'refreshIframe',
    value: function refreshIframe(props) {

      var iframe = _reactDom2['default'].findDOMNode(this.refs.iframe);

      if (iframe) {
        (function () {

          var iframeDoc = iframe.contentDocument || iframe.contentWindow.document;

          iframeDoc.close();

          var styles = props.previewConfig.styles || [];
          var scripts = props.previewConfig.scripts || [];

          var headBlocks = [];
          var codeBlocks = [];

          styles.forEach(function (link) {
            headBlocks.push('<link rel=\'stylesheet\' href=\'' + link + '\'/> ');
          });

          scripts.forEach(function (link) {
            codeBlocks.push('<script src=\'' + link + '\'></script>');
          });

          var script = '\n        var React = require(\'react\');\n        var ReactDOM = require(\'react-dom\');\n        var componentModule = {};\n        (function(require, module, exports){\n            ' + props.codeString + '\n        })(components.require, componentModule, {});\n        var Component = componentModule.exports;\n        ReactDOM.render(React.createElement(Component, {}, null), document.getElementById(\'root\'))\n      ';

          codeBlocks.push('<script>' + script + '</script>');

          iframeDoc.open();
          iframeDoc.write('\n      <html>\n        <head>' + headBlocks.join('\n') + '</head>\n        <body>\n          <div id=\'root\'></div>\n          ' + codeBlocks.join('\n') + '\n        </body>\n      </html>');
        })();
      }
    }
  }, {
    key: 'onResize',
    value: function onResize(evt, _ref) {
      var size = _ref.size;

      this.setState(size);
    }
  }, {
    key: 'resizeWidth',
    value: function resizeWidth(evt) {
      this.setState({
        width: parseInt(evt.target.value)
      });
    }
  }, {
    key: 'resizeHeight',
    value: function resizeHeight(evt) {
      this.setState({
        height: parseInt(evt.target.value)
      });
    }
  }, {
    key: 'render',
    value: function render() {

      var state = this.state;

      var styles = {
        width: state.width + 'px', height: state.height + 'px'
      };

      return _react2['default'].createElement(
        'div',
        { className: 'react-preview' },
        _react2['default'].createElement(
          'div',
          { className: 'react-preview__size-input' },
          _react2['default'].createElement(
            'label',
            null,
            _react2['default'].createElement(
              'span',
              null,
              ' width:'
            ),
            _react2['default'].createElement('input', { name: 'width',
              type: 'number',
              value: state.width,
              onChange: this.resizeWidth.bind(this) })
          ),
          _react2['default'].createElement(
            'label',
            null,
            _react2['default'].createElement(
              'span',
              null,
              ' height:'
            ),
            _react2['default'].createElement('input', { name: 'height',
              type: 'number',
              value: state.height,
              onChange: this.resizeHeight.bind(this) })
          )
        ),
        _react2['default'].createElement(
          _Resizable2['default'],
          {
            width: state.width,
            height: state.height,
            className: 'react-preview__resize--container',
            onResize: this.onResize.bind(this) },
          _react2['default'].createElement('iframe', { ref: 'iframe',
            style: styles })
        )
      );
    }
  }]);

  return ReactPreview;
})(_react2['default'].Component);

exports['default'] = ReactPreview;
module.exports = exports['default'];