'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactResizable = require('react-resizable');

var Resizable = (function (_React$Component) {
  _inherits(Resizable, _React$Component);

  _createClass(Resizable, null, [{
    key: 'propTypes',
    value: {
      width: _react.PropTypes.number,
      height: _react.PropTypes.number,
      onResize: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      onResize: function onResize() {
        return null;
      }
    },
    enumerable: true
  }]);

  function Resizable(props) {
    _classCallCheck(this, Resizable);

    _get(Object.getPrototypeOf(Resizable.prototype), 'constructor', this).call(this, props);
    this.state = {
      width: props.width,
      height: props.height
    };
  }

  _createClass(Resizable, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.width !== this.state.width || nextProps.height !== this.state.height) {
        this.setState({
          width: nextProps.width,
          height: nextProps.height
        });
      }
    }
  }, {
    key: 'onResize',
    value: function onResize(evt, _ref) {
      var size = _ref.size;

      this.setState(size);
      this.props.onResize(evt, {
        size: size
      });
    }
  }, {
    key: 'onResizeStop',
    value: function onResizeStop() {
      _reactDom2['default'].findDOMNode(this.refs.mask).classList.remove('show');
    }
  }, {
    key: 'onResizeStart',
    value: function onResizeStart() {
      _reactDom2['default'].findDOMNode(this.refs.mask).classList.add('show');
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var state = this.state;

      var styles = {
        width: state.width + 'px', height: state.height + 'px'
      };

      return _react2['default'].createElement(
        _reactResizable.Resizable,
        {
          width: props.width,
          height: props.height,
          className: props.className,
          minConstraints: [320, 320],
          onResizeStop: this.onResizeStop.bind(this),
          onResizeStart: this.onResizeStart.bind(this),
          onResize: this.onResize.bind(this) },
        _react2['default'].createElement(
          'div',
          { style: styles },
          props.children,
          _react2['default'].createElement('div', { ref: 'mask',
            className: 'react-resizable__mask' })
        )
      );
    }
  }]);

  return Resizable;
})(_react2['default'].Component);

exports['default'] = Resizable;
module.exports = exports['default'];