'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _through2 = require('through2');

var _through22 = _interopRequireDefault(_through2);

var _reactDocgen = require('react-docgen');

var reactDocGen = _interopRequireWildcard(_reactDocgen);

var _libsGetModulePathByVinylFile = require('./libs/getModulePathByVinylFile');

var _libsGetModulePathByVinylFile2 = _interopRequireDefault(_libsGetModulePathByVinylFile);

var _libsGetModuleInfoByVinylFile = require('./libs/getModuleInfoByVinylFile');

var _libsGetModuleInfoByVinylFile2 = _interopRequireDefault(_libsGetModuleInfoByVinylFile);

var _libsDescriptionProcess = require('./libs/descriptionProcess');

var _libsDescriptionProcess2 = _interopRequireDefault(_libsDescriptionProcess);

var _libsGetDocDependenceListByResult = require('./libs/getDocDependenceListByResult');

var _libsGetDocDependenceListByResult2 = _interopRequireDefault(_libsGetDocDependenceListByResult);

var _libsGenerateDocDependenceListByRequireList = require('./libs/generateDocDependenceListByRequireList');

var _libsGenerateDocDependenceListByRequireList2 = _interopRequireDefault(_libsGenerateDocDependenceListByRequireList);

var PLUGIN_NAME = 'react-doc';

function gulpPlugin() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var result = {};

  function docJson(file, enc, cb) {

    file.cwd = options.cwd;

    try {

      var moduleInfo = reactDocGen.parse(String(file.contents));

      if (!_lodash2['default'].isEmpty(moduleInfo)) {
        result[(0, _libsGetModulePathByVinylFile2['default'])(file)] = _lodash2['default'].merge((0, _libsDescriptionProcess2['default'])(moduleInfo, {
          basedir: _path2['default'].dirname(file.path),
          cwd: options.cwd
        }), (0, _libsGetModuleInfoByVinylFile2['default'])(file));
      }
    } catch (err) {
      this.emit('error', new _gulpUtil2['default'].PluginError(PLUGIN_NAME, err));
    }

    return cb();
  }

  function endStream(cb) {

    var filename = options.filename || PLUGIN_NAME;

    var jsonFile = new _gulpUtil2['default'].File({
      path: filename + '.json',
      contents: new Buffer(JSON.stringify(result, null, 2))
    });

    var requireListFile = new _gulpUtil2['default'].File({
      path: filename + '.js',
      contents: new Buffer((0, _libsGenerateDocDependenceListByRequireList2['default'])((0, _libsGetDocDependenceListByResult2['default'])(result)))
    });

    this.push(jsonFile);
    this.push(requireListFile);

    cb();
  }

  return _through22['default'].obj(docJson, endStream);
}

exports['default'] = gulpPlugin;
module.exports = exports['default'];