'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _resolveRequireModuleId = require('./resolveRequireModuleId');

var _resolveRequireModuleId2 = _interopRequireDefault(_resolveRequireModuleId);

function getExampleContents() {
  var tagItem = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  options = _lodash2['default'].clone(options);

  var basedir = options.basedir || process.cwd();

  var contents = undefined;
  var exampleFile = null;

  if (tagItem.title === 'exampleFile') {
    exampleFile = _path2['default'].resolve(basedir, _lodash2['default'].trim(tagItem.description));
    options.basedir = _path2['default'].dirname(exampleFile);
    options.basename = _path2['default'].basename(exampleFile);
    contents = String(_fs2['default'].readFileSync(exampleFile, 'utf-8'));
  } else {
    contents = tagItem.description;
  }

  var imports = [];

  var es6Way = contents.match(/import[^'"]+(\S+)/gm);
  var cjsWay = contents.match(/require\((\S+)\)/gm);

  if (es6Way) {
    imports = imports.concat(es6Way);
  }
  if (cjsWay) {
    imports = imports.concat(cjsWay);
  }

  var requireList = _lodash2['default'].map(imports, function (item) {
    var resolvedPathName = (0, _resolveRequireModuleId2['default'])(item, options);
    return {
      path: resolvedPathName,
      src: item,
      dest: item.replace(/['"](\S+)['"]/gm, '\'' + resolvedPathName + '\'')
    };
  });

  return {
    requireList: requireList,
    contents: _lodash2['default'].reduce(requireList, function (processedContents, requireItem) {
      return processedContents.replace(requireItem.src, requireItem.dest);
    }, contents)
  };
}

exports['default'] = getExampleContents;
module.exports = exports['default'];