'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _constantsExtensions = require('../constants/extensions');

var _constantsExtensions2 = _interopRequireDefault(_constantsExtensions);

function resolveRequireModuleId(originRequireString) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var extensions = options.extensions ? [].concat(options.extensions) : _constantsExtensions2['default'];
  var basedir = options.basedir || process.cwd();
  var filePath = _path2['default'].join(basedir, options.basename || '');
  var pathName = originRequireString.match(/['"](\S+)['"]/)[1];

  var resolvedPathName = undefined;

  if (_lodash2['default'].startsWith(pathName, './') || _lodash2['default'].startsWith(pathName, '../')) {
    resolvedPathName = _path2['default'].resolve(basedir, pathName);
    if (!existsFileWithExtensions(resolvedPathName)) {
      throw new Error(resolvedPathName + ' is not exists, please check file in ' + filePath);
    }
    if (filePath === resolvedPathName) {
      throw new Error('should not require self');
    }
    if (options.cwd) {
      resolvedPathName = _path2['default'].relative(options.cwd, resolvedPathName);
    }
  } else {
    resolvedPathName = pathName;
  }

  if (_lodash2['default'].contains(extensions, _path2['default'].extname(resolvedPathName))) {
    return resolvedPathName.slice(0, -_path2['default'].extname(resolvedPathName).length);
  }

  return resolvedPathName;
}

function existsFileWithExtensions(resolvedPathName) {
  return [null].concat(_constantsExtensions2['default']).reduce(function (result, ext) {
    return result || _fs2['default'].existsSync(resolvedPathName + (ext || ''));
  }, false);
}

exports['default'] = resolveRequireModuleId;
module.exports = exports['default'];